extends Node3D

@export var prevent_fade_in = true

@onready var environment: Environment = $WorldEnvironment.environment

# Default value in frames set in the Project Settings. Change accordingly if you use a non-default value.
var sdfgi_frames_to_converge: int = 30

# The frame number on which the anti-fade in was reset.
var started_converge_frame := 0


func _process(delta: float) -> void:
	return
	if prevent_fade_in:
		environment.sdfgi_energy = clamp(
				float(sdfgi_frames_to_converge) / (Engine.get_frames_drawn() - started_converge_frame),
				1.0,
				sdfgi_frames_to_converge
			)


func _input(event: InputEvent) -> void:
	if event.is_action_pressed(&"toggle_sdfgi"):
		environment.sdfgi_enabled = not environment.sdfgi_enabled

		if environment.sdfgi_enabled:
			reset_prevent_fade_in()


func reset_prevent_fade_in() -> void:
	started_converge_frame = Engine.get_frames_drawn()
